#!/bin/sh
#copyright 01micko 2011
#GPL3 see /usr/share/doc/legal/
#NO warranty
# simple prog to arrange desk icons
#ver="0.8" #120531
#121224 rodin.s update for i18n
#150115 radky: if not Slacko, exclude Spup/Slacko option; add deskicons.svg and driveicons.svg; enable restart of X-server in openbox/openbox-session and lxsession (func file); window-position=2; define $GTKDIALOG
#160312 radky: remove obsolete icon options for legacy lupu, luci and spup; add option for 'trash icon only'
#160712 radky: adjust check for rox running (call busybox ps else standard ps)
#161219 radky: minor code adjustment
#180925 radky: remove option for 'no drive icons' (woof-ce no longer supports)

export TEXTDOMAIN=desksetup
export OUTPUT_CHARSET=UTF-8

if [ "`which gtkdialog4`" ]; then
 GTKDIALOG=gtkdialog4
elif [ "`which gtkdialog3`" ]; then
 GTKDIALOG=gtkdialog3
else
 GTKDIALOG=gtkdialog
fi

#is rox running? #160712
if [ "`which busybox`" ]; then
 ROXRUNNING=`busybox ps|grep -a "/usr/local/apps/ROX-Filer/ROX-Filer -p /root/Choices/ROX-Filer/PuppyPin"|grep -av "grep"`
else
 ROXRUNNING=`ps -ax|grep -a "/usr/local/apps/ROX-Filer/ROX-Filer -p /root/Choices/ROX-Filer/PuppyPin"|grep -av "grep"`
fi
[ "$ROXRUNNING" = "" ]&& gtkdialog-splash -icon gtk-dialog-error -timeout 5 -deco deskset -fontsize large -bg hotpink -close never -text "`gettext \"ERROR: Rox pinboard (PuppyPin) is not running. You can't use this application\"`" && exit
#eventmanager has a bug where pristine it has double quotes arround bool statements, after evenmanager is run they disappear
HASQUOTES=`grep '"' /etc/eventmanager`
if [[ "$HASQUOTES" != "" ]];then #110120
 sed -i 's/\"//g' /etc/eventmanager
fi 

. /etc/eventmanager
#get radio defaults for drive icons from /etc/eventmanager
TABLABEL="$(gettext 'Desk Icons')"
DRIVEICONS=""

if [ "$ICONDESK" -a "$ICONPARTITIONS" ]; then
 if [[ "$ICONDESK" = "false" && "$ICONPARTITIONS" = "true" ]];then
  RADIO6=false
  RADIO7=false
  RADIO8=false
  elif [[ "$ICONDESK" = "true" && "$ICONPARTITIONS" = "true" ]];then
   RADIO6=true
   RADIO7=false
   RADIO8=false
  elif [[ "$ICONDESK" = "true" && "$ICONPARTITIONS" = "false" ]];then
   RADIO6=false
   RADIO7=true
   RADIO8=false
  elif [[ "$ICONDESK" = "false" && "$ICONPARTITIONS" = "false" ]];then
   RADIO6=false
   RADIO7=false
   RADIO8=true
 fi

 TABLABEL="$(gettext 'Desk Icons|Drive Icons')"

 DRIVEICONS="
  <vbox>
   <pixmap>
    <input file>/usr/share/pixmaps/driveicons.svg</input><height>42</height><width>42</width>
   </pixmap>
   <text use-markup=\"true\"><label>\"<b>$(gettext 'Drive Icons')</b>\"</label></text>
   <hseparator></hseparator>
   <radiobutton tooltip-text=\"`gettext \"This is the default for all puppies, each partition will have it's own icon as will plugged drives\"`\">
	<label>\"$(gettext 'Traditional -an icon for each partition')\"</label>
	<variable>RADIO6</variable>
	
	<default>$RADIO6</default>
   </radiobutton>
   <radiobutton tooltip-text=\"$(gettext 'There will be only the root of the drives on the desktop')\">
	<label>\"$(gettext 'Lean -only root drive icons')\"</label>
	<variable>RADIO7</variable>
	
	<default>$RADIO7</default>
   </radiobutton>
   <radiobutton tooltip-text=\"$(gettext 'There will be only 1 drive icon which starts Pmount')\">
	<label>\"$(gettext 'Minimal -one drive icon')\"</label>
	<variable>RADIO8</variable>
	
	<default>$RADIO8</default>
   </radiobutton>
  </vbox>"
fi

#define working directorys
APPDIR="`dirname $0`"
[ "$APPDIR" = "." ] && APPDIR="`pwd`"
export APPDIR="$APPDIR"

#define config dir/file
CONFDIR="$HOME/.desksetup"
CONFFILE="$CONFDIR/desk.conf"
#export $CONFFILE
cp -af $CONFFILE ${CONFFILE}.bak
. $CONFFILE

#define Trash option
TRASH=""
if [ -d /usr/local/apps/Trash ]; then
 TRASH="   <radiobutton tooltip-text=\"$(gettext 'Single icon to manage deleted files')\">
	<label>\"$(gettext 'Trash icon only')\"</label>
	<variable>RADIO4</variable>
	<action>if true sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=true/' $CONFFILE</action>
	<action>if false sed -i 's/RADIO4=[a-z]*[a-z]/RADIO4=false/' $CONFFILE</action>
	<default>$RADIO4</default>
   </radiobutton>"
fi

#title-bar icon #140930
ln -sf /usr/share/pixmaps/deskicons.svg /usr/share/icons/hicolor/48x48/apps && gtk-update-icon-cache -f -i /usr/share/icons/hicolor 2>/dev/null

#gui
export deskset="<window title=\"$(gettext 'Desktop Icon Setup') $ver\"  icon-name=\"deskicons\" window-position=\"2\">
 <vbox>
  <notebook labels=\"$TABLABEL\">
   <vbox>
   <pixmap>
    <input file>/usr/share/pixmaps/deskicons.svg</input><height>42</height><width>42</width>
   </pixmap>
   <text use-markup=\"true\"><label>\"<b>$(gettext 'Desk Icons')</b>\"</label></text>
   <hseparator></hseparator>
   <radiobutton tooltip-text=\"$(gettext 'This is the standard Puppy desktop that has been a tradition since Barry Kauler started Puppy in 2003, for purists')\">
	<label>\"$(gettext 'Traditional -full desktop icons')\"</label>
	<variable>RADIO1</variable>
	<action>if true sed -i 's/RADIO1=[a-z]*[a-z]/RADIO1=true/' $CONFFILE</action>
	<action>if false sed -i 's/RADIO1=[a-z]*[a-z]/RADIO1=false/' $CONFFILE</action>
	<default>$RADIO1</default>
   </radiobutton>
   <radiobutton tooltip-text=\"$(gettext 'This includes just the file, edit, console, browse and trash icons, for those who move fast')\">
	<label>\"$(gettext 'Minimal -essential desktop icons')\"</label>
	<variable>RADIO2</variable>
	<action>if true sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=true/' $CONFFILE</action>
	<action>if false sed -i 's/RADIO2=[a-z]*[a-z]/RADIO2=false/' $CONFFILE</action>
	<default>$RADIO2</default>
   </radiobutton>
   <radiobutton tooltip-text=\"$(gettext 'There will be no application icons on the desktop, this is for minimalists')\">
	<label>\"$(gettext 'Bare -no desktop icons')\"</label>
	<variable>RADIO3</variable>
	<action>if true sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=true/' $CONFFILE</action>
	<action>if false sed -i 's/RADIO3=[a-z]*[a-z]/RADIO3=false/' $CONFFILE</action>
	<default>$RADIO3</default>
   </radiobutton>
   ${TRASH}
   <radiobutton tooltip-text=\"$(gettext 'This will display your saved custom pinboard')\">
	<label>\"$(gettext 'Custom -choose your saved profile')\"</label>
	<variable>RADIO5</variable>
	<action>if true sed -i 's/RADIO5=[a-z]*[a-z]/RADIO5=true/' $CONFFILE</action>
	<action>if false sed -i 's/RADIO5=[a-z]*[a-z]/RADIO5=false/' $CONFFILE</action>
	<default>$RADIO5</default>
   </radiobutton>
   <hbox>
   <text><label>$(gettext 'Click this button to save your custom arrangement')</label></text>
   <button tooltip-text=\"$(gettext 'Clicking here will save your desktop changes to a customised file. Be aware that this omits drive icons')\">
    <input file stock=\"gtk-save\"></input>
    <action>. $APPDIR/func customsave &</action>
   </button>
   </hbox>
  </vbox>
  
  ${DRIVEICONS}

 </notebook>
  <hbox homogeneous=\"true\">
   <text use-markup=\"true\"><label>\"<i>$(gettext 'When <b>Apply</b> is clicked X will restart')</i>\"</label></text>
  </hbox>
  <hbox>
   <button tooltip-text=\"$(gettext 'Clicking Apply will save your changes and restart the X server. Be sure you have saved all your work')\">
    <input file stock=\"gtk-apply\"></input>
    <label>$(gettext 'Apply')</label>
    <action>. $APPDIR/func apply &</action>
    <action>exit:applied</action>
   </button>
   <button>
    <input file stock=\"gtk-quit\"></input>
    <label>$(gettext 'Quit')</label>
    <action>cp -af ${CONFFILE}.bak $CONFFILE </action>
    <action>exit:closed</action>
   </button>
  </hbox>
 </vbox>
</window>
"
$GTKDIALOG -p deskset
unset deskset
#end
